/*
Working solution
by Marek Zeman, 20.6.2010
Task 'real fun', CPSPC 2010
   */

#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <stack>
#include <vector>
#include <cmath>
#include <list>
#include <sstream>
#include <algorithm>

using namespace std;

typedef pair<int,int> PII;
typedef long long LL; 
typedef vector<int> VI; 
typedef pair<LL,LL> PLL;
typedef vector<pair<int,int> > VPII;
typedef vector<LL> VLL;
typedef vector<vector<int> > VVI;
typedef vector<string> VS; 
typedef long double LD; 

#define PI 3.14159265358979323
#define EE 2.71828182845
#define EPS 10e-10
#define INF 10000000

inline LL MAX(LL a, LL b){ return a < b ? b : a;} 
inline LL MIN(LL a, LL b){ return a < b ? a : b;} 

#define FOR(i,n)      for(int i=0;i<(n);i++)
#define FORD(i,n)     for(int i=(n)-1;i>=0;i--)

#define MP make_pair
#define PB push_back

#define TOPCOR 1000000000
#define BOTCOR -1000000000

int topx,botx,topy,boty,N;
int PX[200500],PY[200500],mask[205000];

//verifies, whether set of points can be covered
//by two squares with side 'd'
bool verify2(LL d){
  int botx=TOPCOR,boty=TOPCOR,topx=BOTCOR,topy=BOTCOR;
  int pocet = 0;
  FOR(i,N) if (mask[i] == 0){
    pocet++;
    if (PX[i] < botx) botx = PX[i];
    if (PX[i] > topx) topx = PX[i];
    if (PY[i] < boty) boty = PY[i];
    if (PY[i] > topy) topy = PY[i];
  }

  if (pocet < 3) return true;
  if (topx - botx <= d && topy - boty <= d) return true;
  
  int ok = 1;

  //square in the top left (and bottom right)
  FOR(i,N)if (mask[i] == 0){
    if ( PX[i] - botx <= d && topy - PY[i] <=d ) continue;
    if ( topx - PX[i] <= d && PY[i] - boty <=d ) continue;
    ok = 0;
    break;
  }
  if (ok == 1) return true;

  //square in the top right (and bottom left)
  ok = 1;
  FOR(i,N)if (mask[i] == 0){
    if ( PY[i] - boty <= d && PX[i] - botx <=d ) continue;
    if ( topy - PY[i] <= d && topx - PX[i] <=d ) continue;
    ok = 0;
    break;
  }
  if (ok == 1) return true;

  return false;
}

//verifies, whether set of points can be 
//covered by three squares of side 'd'
//idea: there must be a square in a corner
bool verify(LL d){
  memset( mask, 0, sizeof( mask ) );

  memset( mask, 0, sizeof( mask ) );
  //bottom left corner
  FOR(i,N) if ( (PX[i] - botx <= d) && (PY[i] - boty <= d) ) mask[i] = 1;
  if (verify2(d)) return true;
  //

  memset( mask, 0, sizeof( mask ) );
  //bottom right corner
  FOR(i,N) if ( (topx - PX[i] <= d) && (PY[i] - boty <= d) ) mask[i] = 1;
  if (verify2(d)) return true;
  //

  memset( mask, 0, sizeof( mask ) );
  //top left corner
  FOR(i,N) if ( (PX[i] - botx <= d) && (topy - PY[i] <= d) ) mask[i] = 1;
  if (verify2(d)) return true;
  //

  memset( mask, 0, sizeof( mask ) );
  //top right corner
  FOR(i,N) if ( (topx - PX[i] <= d) && (topy - PY[i] <= d) ) mask[i] = 1;
  if (verify2(d)) return true;
  //

  return false;
}

int main(){
  topx = BOTCOR;
  topy = BOTCOR;
  botx = TOPCOR;
  boty = TOPCOR;
  scanf("%d ",&N);
  FOR(i,N){
    scanf("%d %d ",&PX[i],&PY[i]);
    if (PX[i] < botx) botx = PX[i];
    if (PX[i] > topx) topx = PX[i];
    if (PY[i] < boty) boty = PY[i];
    if (PY[i] > topy) topy = PY[i];
  }
 LL hi = 2000000000;
  LL lo = 1;
  while( hi - lo > 1){
    LL m = (hi+lo)/2;
    if (verify(m)){ hi = m; }
    else{ lo = m; }
  }
  if ( verify(lo) ){ printf("%d\n",(int)lo); }
  else{ printf("%d\n",(int)hi); }
  return 0;
}

